import java.util.*;

/** MetricEmbedded requires method distanceTo, encoding
 * a distance metric */
public interface MetricEmbedded extends Comparator {
    
    /** a non-negative double representing
      * the value of a distance metric d on this object
      * and obj. 
      * Throw a ClassCastException if obj cannot be cast to
      * the class of this MetricEmbedded. */
    double distanceTo(Object obj);   
    
    /** = -1, 0, or 1 depending on whether as obj1 is MetricEmbedded with 
      * distance to this MetricEmbedded object less than,
      * equal to, or greater than the distance this 
      * MetricEmbedded object from obj2, where distance is measured
      * by distanceTo.
      * Throws a ClassCastException if either obj1 or obj2 
      * cannot be cast to the class of this object. */
     int compare(Object obj1, Object obj2);
    
}